﻿using HarmonyLib;
using UnityEngine;

public class BetterPause : Mod
{

    private static BetterPause instance;

    private bool wasPaused = false;
    //private bool wasInvurnerable = false;
    private float stat_thirst, stat_thirst_bonus, stat_hunger, stat_hunger_bonus;

    Harmony harmony;

    public void Start()
    {
        instance = this;

        harmony = new Harmony("net.hypexmon5ter.BetterPause");
        harmony.PatchAll();

        Debug.Log("Mod BetterPause has been loaded!");
    }

    public void OnModUnload()
    {
        harmony.UnpatchAll(harmony.Id);

        Debug.Log("Mod BetterPause has been unloaded!");
    }

    public void Update()
    {
        bool paused = CanvasHelper.ActiveMenu.Equals(MenuType.PauseMenu);

        if (paused)
        {
            if (!wasPaused)
            {
                stat_thirst = RAPI.GetLocalPlayer().Stats.stat_thirst.Normal.Value;
                stat_thirst_bonus = RAPI.GetLocalPlayer().Stats.stat_thirst.Bonus.Value;
                stat_hunger = RAPI.GetLocalPlayer().Stats.stat_hunger.Normal.Value;
                stat_hunger_bonus = RAPI.GetLocalPlayer().Stats.stat_hunger.Bonus.Value;
                /*wasInvurnerable = RAPI.GetLocalPlayer().Stats.IsInvurnerable;
                RAPI.GetLocalPlayer().Stats.IsInvurnerable = true;*/
            }
            else
            {
                stat_thirst = Mathf.Max(stat_thirst, RAPI.GetLocalPlayer().Stats.stat_thirst.Normal.Value);
                stat_thirst_bonus = Mathf.Max(stat_thirst_bonus, RAPI.GetLocalPlayer().Stats.stat_thirst.Bonus.Value);
                stat_hunger = Mathf.Max(stat_hunger, RAPI.GetLocalPlayer().Stats.stat_hunger.Normal.Value);
                stat_hunger_bonus = Mathf.Max(stat_hunger_bonus, RAPI.GetLocalPlayer().Stats.stat_hunger.Bonus.Value);
            }

            RAPI.GetLocalPlayer().Stats.stat_thirst.Normal.Value = stat_thirst;
            RAPI.GetLocalPlayer().Stats.stat_thirst.Bonus.Value = stat_thirst_bonus;
            RAPI.GetLocalPlayer().Stats.stat_hunger.Normal.Value = stat_hunger;
            RAPI.GetLocalPlayer().Stats.stat_hunger.Bonus.Value = stat_hunger_bonus;
        }

        wasPaused = paused;
        
        /*if (!wasInvurnerable)
        {
            RAPI.GetLocalPlayer().Stats.IsInvurnerable = false;
        }*/
    }
}

[HarmonyPatch(typeof(BuffDisplayObject), "Update")]
public class Patch_BuffDisplayObject
{
    [HarmonyPrefix]
    static bool Postfix()
    {
        if (CanvasHelper.ActiveMenu.Equals(MenuType.PauseMenu))
        {
            return false;
        }
        return true;
    }
}